export declare class BaseClientProxy {
    static defaultHeaders: {
        [key: string]: string;
    };
    protected transformOptions(options_: any): Promise<any>;
}
export declare class ContextClient extends BaseClientProxy {
    private http;
    private baseUrl;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined;
    constructor(baseUrl?: string, http?: {
        fetch(url: RequestInfo, init?: RequestInit): Promise<Response>;
    });
    getContext(): Promise<YodaServiceResultOfContextDTO | null>;
    protected processGetContext(response: Response): Promise<YodaServiceResultOfContextDTO | null>;
}
export declare class FieldSummaryClient extends BaseClientProxy {
    private http;
    private baseUrl;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined;
    constructor(baseUrl?: string, http?: {
        fetch(url: RequestInfo, init?: RequestInit): Promise<Response>;
    });
    getSummaryById(id: number): Promise<YodaServiceResultOfCovipFieldSummary | null>;
    protected processGetSummaryById(response: Response): Promise<YodaServiceResultOfCovipFieldSummary | null>;
    updateFields(id: number, updatedValue: CovipFieldSummary | null): Promise<YodaServiceResultOfCovipFieldSummary | null>;
    protected processUpdateFields(response: Response): Promise<YodaServiceResultOfCovipFieldSummary | null>;
    countFields(): Promise<YodaServiceResultOfInt64 | null>;
    protected processCountFields(response: Response): Promise<YodaServiceResultOfInt64 | null>;
    listFields(orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null>;
    protected processListFields(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null>;
    countFixedFields(): Promise<YodaServiceResultOfInt64 | null>;
    protected processCountFixedFields(response: Response): Promise<YodaServiceResultOfInt64 | null>;
    listFixedFields(orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null>;
    protected processListFixedFields(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null>;
    countSubFixed(provider: string | null, fieldSummary: number): Promise<YodaServiceResultOfInt64 | null>;
    protected processCountSubFixed(response: Response): Promise<YodaServiceResultOfInt64 | null>;
    subFixed(provider: string | null, fieldSummary: number, orderBy: string | null, pageIndex: number | null, pageSize: number | null): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null>;
    protected processSubFixed(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null>;
    getListPortfolios(provider: string | null, target: string | null, orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null>;
    protected processGetListPortfolios(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null>;
    getListValues(provider: string | null, target: string | null, orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null>;
    protected processGetListValues(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null>;
    portfoliosListCount(provider: string | null, target: string | null): Promise<YodaServiceResultOfInt64 | null>;
    protected processPortfoliosListCount(response: Response): Promise<YodaServiceResultOfInt64 | null>;
    valuesListCount(provider: string | null, target: string | null): Promise<YodaServiceResultOfInt64 | null>;
    protected processValuesListCount(response: Response): Promise<YodaServiceResultOfInt64 | null>;
    getFirstValueTargets(provider: string | null): Promise<YodaServiceResultOfString | null>;
    protected processGetFirstValueTargets(response: Response): Promise<YodaServiceResultOfString | null>;
    getValueTargetsCount(provider: string | null, filter: string | null | undefined): Promise<YodaServiceResultOfInt32 | null>;
    protected processGetValueTargetsCount(response: Response): Promise<YodaServiceResultOfInt32 | null>;
    getValueTargets(provider: string | null, filter: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfString | null>;
    protected processGetValueTargets(response: Response): Promise<YodaServiceResultOfIEnumerableOfString | null>;
    getFirstPortfolioTarget(provider: string | null): Promise<YodaServiceResultOfString | null>;
    protected processGetFirstPortfolioTarget(response: Response): Promise<YodaServiceResultOfString | null>;
    getPortfolioTargets(provider: string | null, filter: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfString | null>;
    protected processGetPortfolioTargets(response: Response): Promise<YodaServiceResultOfIEnumerableOfString | null>;
    getPortfolioTargetsCount(provider: string | null, filter: string | null | undefined): Promise<YodaServiceResultOfInt32 | null>;
    protected processGetPortfolioTargetsCount(response: Response): Promise<YodaServiceResultOfInt32 | null>;
}
export declare class FieldValueClient extends BaseClientProxy {
    private http;
    private baseUrl;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined;
    constructor(baseUrl?: string, http?: {
        fetch(url: RequestInfo, init?: RequestInit): Promise<Response>;
    });
    listValues(summaryId: number, provider: string | null, orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipFieldValue | null>;
    protected processListValues(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFieldValue | null>;
    countValues(summaryId: number, provider: string | null): Promise<YodaServiceResultOfIEnumerableOfCovipFieldValue | null>;
    protected processCountValues(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFieldValue | null>;
    getById(id: number): Promise<YodaServiceResultOfCovipFieldValue | null>;
    protected processGetById(response: Response): Promise<YodaServiceResultOfCovipFieldValue | null>;
    updateValue(id: number, updatedValue: CovipFieldValue | null): Promise<YodaServiceResultOfCovipFieldValue | null>;
    protected processUpdateValue(response: Response): Promise<YodaServiceResultOfCovipFieldValue | null>;
    deleteValue(id: number): Promise<YodaServiceResultOfBoolean | null>;
    protected processDeleteValue(response: Response): Promise<YodaServiceResultOfBoolean | null>;
    loadValues(parameters: LoadValueParameters | null): Promise<YodaServiceResultOfBoolean | null>;
    protected processLoadValues(response: Response): Promise<YodaServiceResultOfBoolean | null>;
    loadIssuer(): Promise<YodaServiceResultOfTaskOfBoolean | null>;
    protected processLoadIssuer(response: Response): Promise<YodaServiceResultOfTaskOfBoolean | null>;
    createTargetFields(newValue: CreateTargetParameters | null): Promise<YodaServiceResultOfBoolean | null>;
    protected processCreateTargetFields(response: Response): Promise<YodaServiceResultOfBoolean | null>;
    createValue(newValue: CovipFieldValue | null): Promise<YodaServiceResultOfCovipFieldValue | null>;
    protected processCreateValue(response: Response): Promise<YodaServiceResultOfCovipFieldValue | null>;
}
export declare class OutputClient extends BaseClientProxy {
    private http;
    private baseUrl;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined;
    constructor(baseUrl?: string, http?: {
        fetch(url: RequestInfo, init?: RequestInit): Promise<Response>;
    });
    countOutput(fileTransferId: number | undefined): Promise<YodaServiceResultOfInt64 | null>;
    protected processCountOutput(response: Response): Promise<YodaServiceResultOfInt64 | null>;
    listOutput(fileTransferId: number | undefined, orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipOutput | null>;
    protected processListOutput(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipOutput | null>;
    listFileTransfer(): Promise<YodaServiceResultOfIEnumerableOfCovipFileTransfer | null>;
    protected processListFileTransfer(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFileTransfer | null>;
    updateOutput(id: number, updatedValue: CovipOutput | null): Promise<YodaServiceResultOfCovipOutput | null>;
    protected processUpdateOutput(response: Response): Promise<YodaServiceResultOfCovipOutput | null>;
    deleteOutput(id: number): Promise<YodaServiceResultOfBoolean | null>;
    protected processDeleteOutput(response: Response): Promise<YodaServiceResultOfBoolean | null>;
    createOutput(newValue: CovipOutput | null): Promise<YodaServiceResultOfCovipOutput | null>;
    protected processCreateOutput(response: Response): Promise<YodaServiceResultOfCovipOutput | null>;
}
export declare class ProviderClient extends BaseClientProxy {
    private http;
    private baseUrl;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined;
    constructor(baseUrl?: string, http?: {
        fetch(url: RequestInfo, init?: RequestInit): Promise<Response>;
    });
    getAvailableProviders(): Promise<YodaServiceResultOfIEnumerableOfString | null>;
    protected processGetAvailableProviders(response: Response): Promise<YodaServiceResultOfIEnumerableOfString | null>;
}
export declare class DaveAuthorizationClient extends BaseClientProxy {
    private http;
    private baseUrl;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined;
    constructor(baseUrl?: string, http?: {
        fetch(url: RequestInfo, init?: RequestInit): Promise<Response>;
    });
    logon(): Promise<void>;
    protected processLogon(response: Response): Promise<void>;
    logout(): Promise<void>;
    protected processLogout(response: Response): Promise<void>;
}
export declare class DaveHealthClient extends BaseClientProxy {
    private http;
    private baseUrl;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined;
    constructor(baseUrl?: string, http?: {
        fetch(url: RequestInfo, init?: RequestInit): Promise<Response>;
    });
    doPing(): Promise<void>;
    protected processDoPing(response: Response): Promise<void>;
    get(): Promise<any | null>;
    protected processGet(response: Response): Promise<any | null>;
}
export interface YodaServiceResultOfContextDTO {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: ContextDTO | undefined;
    Status: boolean;
}
export interface YodaErrorDetail {
    Message?: string | undefined;
    StackTrace?: string | undefined;
    Code: number;
}
export interface ContextDTO {
    IsCanEditSystemTables: boolean;
    DefaultCompany?: string | undefined;
    DefaultProvider?: string | undefined;
}
export interface YodaServiceResultOfCovipFieldSummary {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFieldSummary | undefined;
    Status: boolean;
}
export interface CovipFieldSummary {
    Id: number;
    Name?: string | undefined;
    Description?: string | undefined;
    IsFixed: boolean;
    IsPortfolio: boolean;
    Scope?: string | undefined;
    Source?: string | undefined;
    Type?: string | undefined;
    Format?: string | undefined;
    HasFixedValue?: boolean | undefined;
    FieldValue?: CovipFieldValue[] | undefined;
    ValueList?: CovipValueList[] | undefined;
}
export interface CovipFieldValue {
    Id?: number | undefined;
    Provider?: string | undefined;
    FieldSummaryId: number;
    Target?: string | undefined;
    Value?: string | undefined;
    HasValue?: boolean | undefined;
}
export interface CovipValueList {
    Id: number;
    FieldSummaryId?: number | undefined;
    FieldValue?: string | undefined;
    FieldValueDescription?: string | undefined;
}
export interface YodaServiceResultOfInt64 {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result: number;
    Status: boolean;
}
export interface YodaServiceResultOfIEnumerableOfCovipFieldSummary {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFieldSummary[] | undefined;
    Status: boolean;
}
export interface YodaServiceResultOfIEnumerableOfCovipObject {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipObject[] | undefined;
    Status: boolean;
}
export interface CovipObject {
    Scope?: string | undefined;
    Name?: string | undefined;
    Description?: string | undefined;
    HasValue?: boolean | undefined;
    Value?: string | undefined;
    FieldSummaryId: number;
    Id: number;
    Target?: string | undefined;
    IsPortfolio: boolean;
    IsFixed: boolean;
    Type?: string | undefined;
    Format?: string | undefined;
    HasFixedValue?: boolean | undefined;
    ValueList?: CovipValueList[] | undefined;
}
export interface YodaServiceResultOfString {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: string | undefined;
    Status: boolean;
}
export interface YodaServiceResultOfInt32 {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result: number;
    Status: boolean;
}
export interface YodaServiceResultOfIEnumerableOfString {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: string[] | undefined;
    Status: boolean;
}
export interface YodaServiceResultOfIEnumerableOfCovipFieldValue {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFieldValue[] | undefined;
    Status: boolean;
}
export interface YodaServiceResultOfCovipFieldValue {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFieldValue | undefined;
    Status: boolean;
}
export interface LoadValueParameters {
    SummaryType: FieldSummaryType;
    SourceProvider?: string | undefined;
    DestinationProvider?: string | undefined;
    DeleteDestination: boolean;
    FieldSummaryId?: number | undefined;
}
export declare enum FieldSummaryType {
    Fixed = 0,
    Portfolio = 1,
    NotFixedAndNotPortfolio = 2,
    All = 3
}
export interface YodaServiceResultOfBoolean {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result: boolean;
    Status: boolean;
}
export interface YodaServiceResultOfTaskOfBoolean {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: boolean | undefined;
    Status: boolean;
}
export interface CreateTargetParameters {
    Provider?: string | undefined;
    Name?: string | undefined;
    Type: TargetType;
}
export declare enum TargetType {
    FUND = 0
}
export interface YodaServiceResultOfIEnumerableOfCovipOutput {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipOutput[] | undefined;
    Status: boolean;
}
export interface CovipOutput {
    OuputId?: number | undefined;
    PortfolioCode?: string | undefined;
    Company?: string | undefined;
    SingleFund: boolean;
    FileTransferId: number;
}
export interface YodaServiceResultOfIEnumerableOfCovipFileTransfer {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFileTransfer[] | undefined;
    Status: boolean;
}
export interface CovipFileTransfer {
    Id: number;
    Name?: string | undefined;
    Provider?: string | undefined;
    TargetContext?: string | undefined;
    ZipUnion: boolean;
}
export interface YodaServiceResultOfCovipOutput {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipOutput | undefined;
    Status: boolean;
}
export declare class SwaggerException extends Error {
    message: string;
    status: number;
    response: string;
    headers: {
        [key: string]: any;
    };
    result: any;
    constructor(message: string, status: number, response: string, headers: {
        [key: string]: any;
    }, result: any);
    protected isSwaggerException: boolean;
    static isSwaggerException(obj: any): obj is SwaggerException;
}
