﻿/* tslint:disable */
//----------------------
// <auto-generated>
//     Generated using the NSwag toolchain v11.17.13.0 (NJsonSchema v9.10.50.0 (Newtonsoft.Json v9.0.0.0)) (http://NSwag.org)
// </auto-generated>
//----------------------
// ReSharper disable InconsistentNaming

export class BaseClientProxy {
    public static defaultHeaders : {[key:string]:string};
    protected transformOptions(options_) {
        // add creds
        options_.credentials = 'include';
        options_.mode = 'cors';
        if ( BaseClientProxy.defaultHeaders) {
            options_.headers = {...options_.headers, ...BaseClientProxy.defaultHeaders};
        }
        return Promise.resolve(options_);
    }

}

export class ContextClient extends BaseClientProxy {
    private http: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> };
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(baseUrl?: string, http?: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> }) {
        super();
        this.http = http ? http : <any>window;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    getContext(): Promise<YodaServiceResultOfContextDTO | null> {
        let url_ = this.baseUrl + "/api/v1/Context";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetContext(_response);
        });
    }

    protected processGetContext(response: Response): Promise<YodaServiceResultOfContextDTO | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfContextDTO>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfContextDTO | null>(<any>null);
    }
}

export class FieldSummaryClient extends BaseClientProxy {
    private http: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> };
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(baseUrl?: string, http?: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> }) {
        super();
        this.http = http ? http : <any>window;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    getSummaryById(id: number): Promise<YodaServiceResultOfCovipFieldSummary | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/{id}";
        if (id === undefined || id === null)
            throw new Error("The parameter 'id' must be defined.");
        url_ = url_.replace("{id}", encodeURIComponent("" + id)); 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetSummaryById(_response);
        });
    }

    protected processGetSummaryById(response: Response): Promise<YodaServiceResultOfCovipFieldSummary | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfCovipFieldSummary>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfCovipFieldSummary | null>(<any>null);
    }

    updateFields(id: number, updatedValue: CovipFieldSummary | null): Promise<YodaServiceResultOfCovipFieldSummary | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/{id}";
        if (id === undefined || id === null)
            throw new Error("The parameter 'id' must be defined.");
        url_ = url_.replace("{id}", encodeURIComponent("" + id)); 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(updatedValue);

        let options_ = <RequestInit>{
            body: content_,
            method: "PUT",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processUpdateFields(_response);
        });
    }

    protected processUpdateFields(response: Response): Promise<YodaServiceResultOfCovipFieldSummary | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfCovipFieldSummary>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfCovipFieldSummary | null>(<any>null);
    }

    countFields(): Promise<YodaServiceResultOfInt64 | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/fieldsCount";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processCountFields(_response);
        });
    }

    protected processCountFields(response: Response): Promise<YodaServiceResultOfInt64 | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfInt64>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfInt64 | null>(<any>null);
    }

    listFields(orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/fieldsList?";
        if (orderBy !== undefined)
            url_ += "orderBy=" + encodeURIComponent("" + orderBy) + "&"; 
        if (pageIndex !== undefined)
            url_ += "pageIndex=" + encodeURIComponent("" + pageIndex) + "&"; 
        if (pageSize !== undefined)
            url_ += "pageSize=" + encodeURIComponent("" + pageSize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processListFields(_response);
        });
    }

    protected processListFields(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfCovipFieldSummary>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null>(<any>null);
    }

    countFixedFields(): Promise<YodaServiceResultOfInt64 | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/fixedCount";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processCountFixedFields(_response);
        });
    }

    protected processCountFixedFields(response: Response): Promise<YodaServiceResultOfInt64 | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfInt64>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfInt64 | null>(<any>null);
    }

    listFixedFields(orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/fixedList?";
        if (orderBy !== undefined)
            url_ += "orderBy=" + encodeURIComponent("" + orderBy) + "&"; 
        if (pageIndex !== undefined)
            url_ += "pageIndex=" + encodeURIComponent("" + pageIndex) + "&"; 
        if (pageSize !== undefined)
            url_ += "pageSize=" + encodeURIComponent("" + pageSize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processListFixedFields(_response);
        });
    }

    protected processListFixedFields(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfCovipFieldSummary>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfCovipFieldSummary | null>(<any>null);
    }

    countSubFixed(provider: string | null, fieldSummary: number): Promise<YodaServiceResultOfInt64 | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/subFixedCount?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (fieldSummary === undefined || fieldSummary === null)
            throw new Error("The parameter 'fieldSummary' must be defined and cannot be null.");
        else
            url_ += "fieldSummary=" + encodeURIComponent("" + fieldSummary) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processCountSubFixed(_response);
        });
    }

    protected processCountSubFixed(response: Response): Promise<YodaServiceResultOfInt64 | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfInt64>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfInt64 | null>(<any>null);
    }

    subFixed(provider: string | null, fieldSummary: number, orderBy: string | null, pageIndex: number | null, pageSize: number | null): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/subFixedList?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (fieldSummary === undefined || fieldSummary === null)
            throw new Error("The parameter 'fieldSummary' must be defined and cannot be null.");
        else
            url_ += "fieldSummary=" + encodeURIComponent("" + fieldSummary) + "&"; 
        if (orderBy === undefined)
            throw new Error("The parameter 'orderBy' must be defined.");
        else
            url_ += "orderBy=" + encodeURIComponent("" + orderBy) + "&"; 
        if (pageIndex === undefined)
            throw new Error("The parameter 'pageIndex' must be defined.");
        else
            url_ += "pageIndex=" + encodeURIComponent("" + pageIndex) + "&"; 
        if (pageSize === undefined)
            throw new Error("The parameter 'pageSize' must be defined.");
        else
            url_ += "pageSize=" + encodeURIComponent("" + pageSize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processSubFixed(_response);
        });
    }

    protected processSubFixed(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfCovipObject>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfCovipObject | null>(<any>null);
    }

    getListPortfolios(provider: string | null, target: string | null, orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/portfoliosList?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (target === undefined)
            throw new Error("The parameter 'target' must be defined.");
        else
            url_ += "target=" + encodeURIComponent("" + target) + "&"; 
        if (orderBy !== undefined)
            url_ += "orderBy=" + encodeURIComponent("" + orderBy) + "&"; 
        if (pageIndex !== undefined)
            url_ += "pageIndex=" + encodeURIComponent("" + pageIndex) + "&"; 
        if (pageSize !== undefined)
            url_ += "pageSize=" + encodeURIComponent("" + pageSize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetListPortfolios(_response);
        });
    }

    protected processGetListPortfolios(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfCovipObject>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfCovipObject | null>(<any>null);
    }

    getListValues(provider: string | null, target: string | null, orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/valuesList?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (target === undefined)
            throw new Error("The parameter 'target' must be defined.");
        else
            url_ += "target=" + encodeURIComponent("" + target) + "&"; 
        if (orderBy !== undefined)
            url_ += "orderBy=" + encodeURIComponent("" + orderBy) + "&"; 
        if (pageIndex !== undefined)
            url_ += "pageIndex=" + encodeURIComponent("" + pageIndex) + "&"; 
        if (pageSize !== undefined)
            url_ += "pageSize=" + encodeURIComponent("" + pageSize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetListValues(_response);
        });
    }

    protected processGetListValues(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipObject | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfCovipObject>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfCovipObject | null>(<any>null);
    }

    portfoliosListCount(provider: string | null, target: string | null): Promise<YodaServiceResultOfInt64 | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/portfoliosCount?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (target === undefined)
            throw new Error("The parameter 'target' must be defined.");
        else
            url_ += "target=" + encodeURIComponent("" + target) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processPortfoliosListCount(_response);
        });
    }

    protected processPortfoliosListCount(response: Response): Promise<YodaServiceResultOfInt64 | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfInt64>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfInt64 | null>(<any>null);
    }

    valuesListCount(provider: string | null, target: string | null): Promise<YodaServiceResultOfInt64 | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/valuesCount?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (target === undefined)
            throw new Error("The parameter 'target' must be defined.");
        else
            url_ += "target=" + encodeURIComponent("" + target) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processValuesListCount(_response);
        });
    }

    protected processValuesListCount(response: Response): Promise<YodaServiceResultOfInt64 | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfInt64>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfInt64 | null>(<any>null);
    }

    getFirstValueTargets(provider: string | null): Promise<YodaServiceResultOfString | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/firstValueTarget?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetFirstValueTargets(_response);
        });
    }

    protected processGetFirstValueTargets(response: Response): Promise<YodaServiceResultOfString | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfString>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfString | null>(<any>null);
    }

    getValueTargetsCount(provider: string | null, filter: string | null | undefined): Promise<YodaServiceResultOfInt32 | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/valueTargetsCount?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (filter !== undefined)
            url_ += "filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetValueTargetsCount(_response);
        });
    }

    protected processGetValueTargetsCount(response: Response): Promise<YodaServiceResultOfInt32 | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfInt32>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfInt32 | null>(<any>null);
    }

    getValueTargets(provider: string | null, filter: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfString | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/valueTargets?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (filter !== undefined)
            url_ += "filter=" + encodeURIComponent("" + filter) + "&"; 
        if (pageIndex !== undefined)
            url_ += "pageIndex=" + encodeURIComponent("" + pageIndex) + "&"; 
        if (pageSize !== undefined)
            url_ += "pageSize=" + encodeURIComponent("" + pageSize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetValueTargets(_response);
        });
    }

    protected processGetValueTargets(response: Response): Promise<YodaServiceResultOfIEnumerableOfString | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfString>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfString | null>(<any>null);
    }

    getFirstPortfolioTarget(provider: string | null): Promise<YodaServiceResultOfString | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/firstPortfolioTarget?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetFirstPortfolioTarget(_response);
        });
    }

    protected processGetFirstPortfolioTarget(response: Response): Promise<YodaServiceResultOfString | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfString>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfString | null>(<any>null);
    }

    getPortfolioTargets(provider: string | null, filter: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfString | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/portfolioTargets?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (filter !== undefined)
            url_ += "filter=" + encodeURIComponent("" + filter) + "&"; 
        if (pageIndex !== undefined)
            url_ += "pageIndex=" + encodeURIComponent("" + pageIndex) + "&"; 
        if (pageSize !== undefined)
            url_ += "pageSize=" + encodeURIComponent("" + pageSize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetPortfolioTargets(_response);
        });
    }

    protected processGetPortfolioTargets(response: Response): Promise<YodaServiceResultOfIEnumerableOfString | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfString>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfString | null>(<any>null);
    }

    getPortfolioTargetsCount(provider: string | null, filter: string | null | undefined): Promise<YodaServiceResultOfInt32 | null> {
        let url_ = this.baseUrl + "/api/v1/FieldSummary/portfolioTargetsCount?";
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (filter !== undefined)
            url_ += "filter=" + encodeURIComponent("" + filter) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetPortfolioTargetsCount(_response);
        });
    }

    protected processGetPortfolioTargetsCount(response: Response): Promise<YodaServiceResultOfInt32 | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfInt32>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfInt32 | null>(<any>null);
    }
}

export class FieldValueClient extends BaseClientProxy {
    private http: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> };
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(baseUrl?: string, http?: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> }) {
        super();
        this.http = http ? http : <any>window;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    listValues(summaryId: number, provider: string | null, orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipFieldValue | null> {
        let url_ = this.baseUrl + "/api/v1/FieldValue/{summaryId}/list?";
        if (summaryId === undefined || summaryId === null)
            throw new Error("The parameter 'summaryId' must be defined.");
        url_ = url_.replace("{summaryId}", encodeURIComponent("" + summaryId)); 
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        if (orderBy !== undefined)
            url_ += "orderBy=" + encodeURIComponent("" + orderBy) + "&"; 
        if (pageIndex !== undefined)
            url_ += "pageIndex=" + encodeURIComponent("" + pageIndex) + "&"; 
        if (pageSize !== undefined)
            url_ += "pageSize=" + encodeURIComponent("" + pageSize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processListValues(_response);
        });
    }

    protected processListValues(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFieldValue | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfCovipFieldValue>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfCovipFieldValue | null>(<any>null);
    }

    countValues(summaryId: number, provider: string | null): Promise<YodaServiceResultOfIEnumerableOfCovipFieldValue | null> {
        let url_ = this.baseUrl + "/api/v1/FieldValue/{summaryId}/count?";
        if (summaryId === undefined || summaryId === null)
            throw new Error("The parameter 'summaryId' must be defined.");
        url_ = url_.replace("{summaryId}", encodeURIComponent("" + summaryId)); 
        if (provider === undefined)
            throw new Error("The parameter 'provider' must be defined.");
        else
            url_ += "provider=" + encodeURIComponent("" + provider) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processCountValues(_response);
        });
    }

    protected processCountValues(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFieldValue | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfCovipFieldValue>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfCovipFieldValue | null>(<any>null);
    }

    getById(id: number): Promise<YodaServiceResultOfCovipFieldValue | null> {
        let url_ = this.baseUrl + "/api/v1/FieldValue/{id}";
        if (id === undefined || id === null)
            throw new Error("The parameter 'id' must be defined.");
        url_ = url_.replace("{id}", encodeURIComponent("" + id)); 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetById(_response);
        });
    }

    protected processGetById(response: Response): Promise<YodaServiceResultOfCovipFieldValue | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfCovipFieldValue>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfCovipFieldValue | null>(<any>null);
    }

    updateValue(id: number, updatedValue: CovipFieldValue | null): Promise<YodaServiceResultOfCovipFieldValue | null> {
        let url_ = this.baseUrl + "/api/v1/FieldValue/{id}";
        if (id === undefined || id === null)
            throw new Error("The parameter 'id' must be defined.");
        url_ = url_.replace("{id}", encodeURIComponent("" + id)); 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(updatedValue);

        let options_ = <RequestInit>{
            body: content_,
            method: "PUT",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processUpdateValue(_response);
        });
    }

    protected processUpdateValue(response: Response): Promise<YodaServiceResultOfCovipFieldValue | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfCovipFieldValue>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfCovipFieldValue | null>(<any>null);
    }

    deleteValue(id: number): Promise<YodaServiceResultOfBoolean | null> {
        let url_ = this.baseUrl + "/api/v1/FieldValue/{id}";
        if (id === undefined || id === null)
            throw new Error("The parameter 'id' must be defined.");
        url_ = url_.replace("{id}", encodeURIComponent("" + id)); 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "DELETE",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processDeleteValue(_response);
        });
    }

    protected processDeleteValue(response: Response): Promise<YodaServiceResultOfBoolean | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfBoolean>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfBoolean | null>(<any>null);
    }

    loadValues(parameters: LoadValueParameters | null): Promise<YodaServiceResultOfBoolean | null> {
        let url_ = this.baseUrl + "/api/v1/FieldValue/loadValues";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(parameters);

        let options_ = <RequestInit>{
            body: content_,
            method: "POST",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processLoadValues(_response);
        });
    }

    protected processLoadValues(response: Response): Promise<YodaServiceResultOfBoolean | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfBoolean>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfBoolean | null>(<any>null);
    }

    loadIssuer(): Promise<YodaServiceResultOfTaskOfBoolean | null> {
        let url_ = this.baseUrl + "/api/v1/FieldValue/loadIssuer";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "POST",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processLoadIssuer(_response);
        });
    }

    protected processLoadIssuer(response: Response): Promise<YodaServiceResultOfTaskOfBoolean | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfTaskOfBoolean>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfTaskOfBoolean | null>(<any>null);
    }

    createTargetFields(newValue: CreateTargetParameters | null): Promise<YodaServiceResultOfBoolean | null> {
        let url_ = this.baseUrl + "/api/v1/FieldValue/createTargetFields";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(newValue);

        let options_ = <RequestInit>{
            body: content_,
            method: "POST",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processCreateTargetFields(_response);
        });
    }

    protected processCreateTargetFields(response: Response): Promise<YodaServiceResultOfBoolean | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfBoolean>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfBoolean | null>(<any>null);
    }

    createValue(newValue: CovipFieldValue | null): Promise<YodaServiceResultOfCovipFieldValue | null> {
        let url_ = this.baseUrl + "/api/v1/FieldValue";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(newValue);

        let options_ = <RequestInit>{
            body: content_,
            method: "POST",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processCreateValue(_response);
        });
    }

    protected processCreateValue(response: Response): Promise<YodaServiceResultOfCovipFieldValue | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfCovipFieldValue>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfCovipFieldValue | null>(<any>null);
    }
}

export class OutputClient extends BaseClientProxy {
    private http: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> };
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(baseUrl?: string, http?: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> }) {
        super();
        this.http = http ? http : <any>window;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    countOutput(fileTransferId: number | undefined): Promise<YodaServiceResultOfInt64 | null> {
        let url_ = this.baseUrl + "/api/v1/Output/outputCount?";
        if (fileTransferId === null)
            throw new Error("The parameter 'fileTransferId' cannot be null.");
        else if (fileTransferId !== undefined)
            url_ += "fileTransferId=" + encodeURIComponent("" + fileTransferId) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processCountOutput(_response);
        });
    }

    protected processCountOutput(response: Response): Promise<YodaServiceResultOfInt64 | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfInt64>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfInt64 | null>(<any>null);
    }

    listOutput(fileTransferId: number | undefined, orderBy: string | null | undefined, pageIndex: number | null | undefined, pageSize: number | null | undefined): Promise<YodaServiceResultOfIEnumerableOfCovipOutput | null> {
        let url_ = this.baseUrl + "/api/v1/Output/outputList?";
        if (fileTransferId === null)
            throw new Error("The parameter 'fileTransferId' cannot be null.");
        else if (fileTransferId !== undefined)
            url_ += "fileTransferId=" + encodeURIComponent("" + fileTransferId) + "&"; 
        if (orderBy !== undefined)
            url_ += "orderBy=" + encodeURIComponent("" + orderBy) + "&"; 
        if (pageIndex !== undefined)
            url_ += "pageIndex=" + encodeURIComponent("" + pageIndex) + "&"; 
        if (pageSize !== undefined)
            url_ += "pageSize=" + encodeURIComponent("" + pageSize) + "&"; 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processListOutput(_response);
        });
    }

    protected processListOutput(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipOutput | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfCovipOutput>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfCovipOutput | null>(<any>null);
    }

    listFileTransfer(): Promise<YodaServiceResultOfIEnumerableOfCovipFileTransfer | null> {
        let url_ = this.baseUrl + "/api/v1/Output/fileTransferList";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processListFileTransfer(_response);
        });
    }

    protected processListFileTransfer(response: Response): Promise<YodaServiceResultOfIEnumerableOfCovipFileTransfer | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfCovipFileTransfer>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfCovipFileTransfer | null>(<any>null);
    }

    updateOutput(id: number, updatedValue: CovipOutput | null): Promise<YodaServiceResultOfCovipOutput | null> {
        let url_ = this.baseUrl + "/api/v1/Output/{id}";
        if (id === undefined || id === null)
            throw new Error("The parameter 'id' must be defined.");
        url_ = url_.replace("{id}", encodeURIComponent("" + id)); 
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(updatedValue);

        let options_ = <RequestInit>{
            body: content_,
            method: "PUT",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processUpdateOutput(_response);
        });
    }

    protected processUpdateOutput(response: Response): Promise<YodaServiceResultOfCovipOutput | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfCovipOutput>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfCovipOutput | null>(<any>null);
    }

    deleteOutput(id: number): Promise<YodaServiceResultOfBoolean | null> {
        let url_ = this.baseUrl + "/api/v1/Output/{id}";
        if (id === undefined || id === null)
            throw new Error("The parameter 'id' must be defined.");
        url_ = url_.replace("{id}", encodeURIComponent("" + id)); 
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "DELETE",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processDeleteOutput(_response);
        });
    }

    protected processDeleteOutput(response: Response): Promise<YodaServiceResultOfBoolean | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfBoolean>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfBoolean | null>(<any>null);
    }

    createOutput(newValue: CovipOutput | null): Promise<YodaServiceResultOfCovipOutput | null> {
        let url_ = this.baseUrl + "/api/v1/Output";
        url_ = url_.replace(/[?&]$/, "");

        const content_ = JSON.stringify(newValue);

        let options_ = <RequestInit>{
            body: content_,
            method: "POST",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processCreateOutput(_response);
        });
    }

    protected processCreateOutput(response: Response): Promise<YodaServiceResultOfCovipOutput | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfCovipOutput>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfCovipOutput | null>(<any>null);
    }
}

export class ProviderClient extends BaseClientProxy {
    private http: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> };
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(baseUrl?: string, http?: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> }) {
        super();
        this.http = http ? http : <any>window;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    getAvailableProviders(): Promise<YodaServiceResultOfIEnumerableOfString | null> {
        let url_ = this.baseUrl + "/api/v1/Provider";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGetAvailableProviders(_response);
        });
    }

    protected processGetAvailableProviders(response: Response): Promise<YodaServiceResultOfIEnumerableOfString | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <YodaServiceResultOfIEnumerableOfString>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<YodaServiceResultOfIEnumerableOfString | null>(<any>null);
    }
}

export class DaveAuthorizationClient extends BaseClientProxy {
    private http: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> };
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(baseUrl?: string, http?: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> }) {
        super();
        this.http = http ? http : <any>window;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    logon(): Promise<void> {
        let url_ = this.baseUrl + "/dave/logon";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "POST",
            headers: {
                "Content-Type": "application/json", 
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processLogon(_response);
        });
    }

    protected processLogon(response: Response): Promise<void> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            return;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<void>(<any>null);
    }

    logout(): Promise<void> {
        let url_ = this.baseUrl + "/dave/logout";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "POST",
            headers: {
                "Content-Type": "application/json", 
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processLogout(_response);
        });
    }

    protected processLogout(response: Response): Promise<void> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            return;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<void>(<any>null);
    }
}

export class DaveHealthClient extends BaseClientProxy {
    private http: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> };
    private baseUrl: string;
    protected jsonParseReviver: ((key: string, value: any) => any) | undefined = undefined;

    constructor(baseUrl?: string, http?: { fetch(url: RequestInfo, init?: RequestInit): Promise<Response> }) {
        super();
        this.http = http ? http : <any>window;
        this.baseUrl = baseUrl ? baseUrl : "";
    }

    doPing(): Promise<void> {
        let url_ = this.baseUrl + "/dave/ping";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processDoPing(_response);
        });
    }

    protected processDoPing(response: Response): Promise<void> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            return;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<void>(<any>null);
    }

    get(): Promise<any | null> {
        let url_ = this.baseUrl + "/dave/health";
        url_ = url_.replace(/[?&]$/, "");

        let options_ = <RequestInit>{
            method: "GET",
            headers: {
                "Content-Type": "application/json", 
                "Accept": "application/json"
            }
        };

        return this.transformOptions(options_).then(transformedOptions_ => {
            return this.http.fetch(url_, transformedOptions_);
        }).then((_response: Response) => {
            return this.processGet(_response);
        });
    }

    protected processGet(response: Response): Promise<any | null> {
        const status = response.status;
        let _headers: any = {}; if (response.headers && response.headers.forEach) { response.headers.forEach((v: any, k: any) => _headers[k] = v); };
        if (status === 200) {
            return response.text().then((_responseText) => {
            let result200: any = null;
            result200 = _responseText === "" ? null : <any>JSON.parse(_responseText, this.jsonParseReviver);
            return result200;
            });
        } else if (status !== 200 && status !== 204) {
            return response.text().then((_responseText) => {
            return throwException("An unexpected server error occurred.", status, _responseText, _headers);
            });
        }
        return Promise.resolve<any | null>(<any>null);
    }
}

export interface YodaServiceResultOfContextDTO {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: ContextDTO | undefined;
    Status: boolean;
}

export interface YodaErrorDetail {
    Message?: string | undefined;
    StackTrace?: string | undefined;
    Code: number;
}

export interface ContextDTO {
    IsCanEditSystemTables: boolean;
    DefaultCompany?: string | undefined;
    DefaultProvider?: string | undefined;
}

export interface YodaServiceResultOfCovipFieldSummary {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFieldSummary | undefined;
    Status: boolean;
}

export interface CovipFieldSummary {
    Id: number;
    Name?: string | undefined;
    Description?: string | undefined;
    IsFixed: boolean;
    IsPortfolio: boolean;
    Scope?: string | undefined;
    Source?: string | undefined;
    Type?: string | undefined;
    Format?: string | undefined;
    HasFixedValue?: boolean | undefined;
    FieldValue?: CovipFieldValue[] | undefined;
    ValueList?: CovipValueList[] | undefined;
}

export interface CovipFieldValue {
    Id?: number | undefined;
    Provider?: string | undefined;
    FieldSummaryId: number;
    Target?: string | undefined;
    Value?: string | undefined;
    HasValue?: boolean | undefined;
}

export interface CovipValueList {
    Id: number;
    FieldSummaryId?: number | undefined;
    FieldValue?: string | undefined;
    FieldValueDescription?: string | undefined;
}

export interface YodaServiceResultOfInt64 {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result: number;
    Status: boolean;
}

export interface YodaServiceResultOfIEnumerableOfCovipFieldSummary {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFieldSummary[] | undefined;
    Status: boolean;
}

export interface YodaServiceResultOfIEnumerableOfCovipObject {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipObject[] | undefined;
    Status: boolean;
}

export interface CovipObject {
    Scope?: string | undefined;
    Name?: string | undefined;
    Description?: string | undefined;
    HasValue?: boolean | undefined;
    Value?: string | undefined;
    FieldSummaryId: number;
    Id: number;
    Target?: string | undefined;
    IsPortfolio: boolean;
    IsFixed: boolean;
    Type?: string | undefined;
    Format?: string | undefined;
    HasFixedValue?: boolean | undefined;
    ValueList?: CovipValueList[] | undefined;
}

export interface YodaServiceResultOfString {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: string | undefined;
    Status: boolean;
}

export interface YodaServiceResultOfInt32 {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result: number;
    Status: boolean;
}

export interface YodaServiceResultOfIEnumerableOfString {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: string[] | undefined;
    Status: boolean;
}

export interface YodaServiceResultOfIEnumerableOfCovipFieldValue {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFieldValue[] | undefined;
    Status: boolean;
}

export interface YodaServiceResultOfCovipFieldValue {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFieldValue | undefined;
    Status: boolean;
}

export interface LoadValueParameters {
    SummaryType: FieldSummaryType;
    SourceProvider?: string | undefined;
    DestinationProvider?: string | undefined;
    DeleteDestination: boolean;
    FieldSummaryId?: number | undefined;
}

export enum FieldSummaryType {
    Fixed = 0, 
    Portfolio = 1, 
    NotFixedAndNotPortfolio = 2, 
    All = 3, 
}

export interface YodaServiceResultOfBoolean {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result: boolean;
    Status: boolean;
}

export interface YodaServiceResultOfTaskOfBoolean {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: boolean | undefined;
    Status: boolean;
}

export interface CreateTargetParameters {
    Provider?: string | undefined;
    Name?: string | undefined;
    Type: TargetType;
}

export enum TargetType {
    FUND = 0, 
}

export interface YodaServiceResultOfIEnumerableOfCovipOutput {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipOutput[] | undefined;
    Status: boolean;
}

export interface CovipOutput {
    OuputId?: number | undefined;
    PortfolioCode?: string | undefined;
    Company?: string | undefined;
    SingleFund: boolean;
    FileTransferId: number;
}

export interface YodaServiceResultOfIEnumerableOfCovipFileTransfer {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipFileTransfer[] | undefined;
    Status: boolean;
}

export interface CovipFileTransfer {
    Id: number;
    Name?: string | undefined;
    Provider?: string | undefined;
    TargetContext?: string | undefined;
    ZipUnion: boolean;
}

export interface YodaServiceResultOfCovipOutput {
    Errors?: YodaErrorDetail[] | undefined;
    IsYodaServiceResult: boolean;
    Result?: CovipOutput | undefined;
    Status: boolean;
}

export class SwaggerException extends Error {
    message: string;
    status: number; 
    response: string; 
    headers: { [key: string]: any; };
    result: any; 

    constructor(message: string, status: number, response: string, headers: { [key: string]: any; }, result: any) {
        super();

        this.message = message;
        this.status = status;
        this.response = response;
        this.headers = headers;
        this.result = result;
    }

    protected isSwaggerException = true;

    static isSwaggerException(obj: any): obj is SwaggerException {
        return obj.isSwaggerException === true;
    }
}

function throwException(message: string, status: number, response: string, headers: { [key: string]: any; }, result?: any): any {
    if(result !== null && result !== undefined)
        throw result;
    else
        throw new SwaggerException(message, status, response, headers, null);
}